### Multinomial Logit model estimation

### Create the data array from the existing dataset
####2018.09.12.ozawa start
####Data <- read.csv("C:/R/Data_Clean_English.csv",header=TRUE)

#ファイル名修正必要

#Data <- read.csv("C:/R/Data_Clean_English.csv",header=TRUE)
#Data <- read.csv("../analysis/test_sampledata02_alternative_mode.csv", header=TRUE)
#Data <- read.csv("../analysis/test_data_collect_03_rev.csv", header=TRUE)
Data <- read.csv("../analysis/test_data_collect_04_rev.csv", header=TRUE)
#write.csv(Data, "../analysis/test_output_03.csv", quote=FALSE, row.names=FALSE)


####2018.09.12.ozawa end

## Count the number of data rows
hh <- nrow(Data)
###hh <- 100



## Set the initial values of the parameters (the number in parenthesis corresponds to the number of parameters to be estimated)

#パラメータは定数項３＋時間１＋料金１
####b0 <- numeric(6)
b0 <- numeric(5)


## Recall that we estimate parameters by maximizing the log-likelihood function, hence we first need to define that function



##### Define the log-likelihood function of the logit model#####



fr <- function(x) {
  
  ### declare the parameters###
  
  ## Alternative specific constants
  
  #定数項
  b1 <- x[1]
  b2 <- x[2]
  b3 <- x[3]
  #b4 <- x[4]
#####  b4 <- 0
  
  ## Travel time to destination
  #所要時間
  d1 <- x[4]

  #料金
  f1 <- x[5]

  ## declare the log-likelihood variable, set value to 0
  LL = 0
  
  ### For this choice problem, we consider the following 5 modes???
  #今回用いる手段は４つ
  ## car
  ## walk
  ## taxi
  ## bike
  
  ## calculate the utility function: :introduce the desired explanatory variables in the function
  
  #walkとbikeのコストは説明変数に入れない
  # time           # fare      # constant
  car   <- exp(d1*Data$X_t_car /10000   +　f1*Data$X_f_car /10      + b1*matrix(1,nrow =hh,ncol=1))
 walk  <- exp(d1*Data$X_t_walk/10000        + b2*matrix(1,nrow =hh,ncol=1))
  taxi  <- exp(d1*Data$X_t_taxi/10000   +　f1*Data$X_t_taxi/10      + b3*matrix(1,nrow =hh,ncol=1))
####  bike  <- exp(d1*Data$X_t_bike/10   +  f1*Data$X_t_bike/10      + b4*matrix(1,nrow =hh,ncol=1))
  bike  <- exp(d1*Data$X_t_bike/10000  )
  
 # car   <- exp(d1*Data$X_t_car /10000   + b1*matrix(1,nrow =hh,ncol=1))
 # walk  <- exp(d1*Data$X_t_walk/10000   + b2*matrix(1,nrow =hh,ncol=1))
 # taxi  <- exp(d1*Data$X_t_taxi/10000   + b3*matrix(1,nrow =hh,ncol=1))
  ####  bike  <- exp(d1*Data$X_t_bike/10   +  f1*Data$X_t_bike/10      + b4*matrix(1,nrow =hh,ncol=1))
 # bike  <- exp(d1*Data$X_t_bike/10000   )
  
  
  
  ### Calculate the choice probabilities
  
  ## calculate the Inclusive Value (the denominator of the choice probabilities equation)
  
  #分母となる、各々のexp(V)の和を作る
  
  deno <- (car + walk + taxi + bike )
  
  
  
  ## Calculate indiviudal choice probabilities
  
  #それぞれ計算
  
  Pcar   <- (car   / deno)
  
  Pwalk <- (walk / deno)
  
  Ptaxi  <- (taxi  / deno)
  
  Pbike  <- (bike  / deno)
  
  
  
  ## Avoid problems stemming from choice probabilities becoming zero.驕ｸ謚樒｢ｺ??????0縺ｫ縺ｪ縺｣縺ｦ縺励∪縺｣縺????蜷医↓襍ｷ縺薙ｋ蝠城｡????蝗樣∩
  
  #選択確率が０になってしまった場合に起こる問題の回避
  
  Pcar   <- (Pcar  !=0)*Pcar   + (Pcar  ==0)
  
  Pwalk  <- (Pwalk!=0)*Pwalk   + (Pwalk  ==0)
  
  Ptaxi  <- (Ptaxi!=0)*Ptaxi   + (Ptaxi==0)
  
  Pbike  <- (Pbike  !=0)*Pbike + (Pbike  ==0)
  
  
  
  
  
  
  ## Choice results
  #選択結果をData$MainModeENG列に表示
  
###  Ccar     <- Data$MainModeENG ==1
###  Cwalk    <- Data$MainModeENG ==2
###  Ctaxi    <- Data$MainModeENG ==3
###  Cbike    <- Data$MainModeENG ==4
  
  
Ccar     <- Data$mode == "自家用車"
Cwalk    <- Data$mode == "タクシー"
Ctaxi    <- Data$mode == "バイク・原付"
Cbike    <- Data$mode == "徒歩"
  
  
  
  
  ## Calculate the Log-likelihood function
  
  #対数尤度の計算
  LL <- colSums(Ccar*log(Pcar) + Cwalk*log(Pwalk) +
                  Ctaxi  *log(Ptaxi)   + Cbike  *log(Pbike) )
  #LL <- colSums(log(Pcar) + log(Pwalk) +
  #                log(Ptaxi)   + log(Pbike) )
}



##### Maximize the Log-likelihood function#####



##Parameter optimization

#対数尤度関数frの最大化

res <- optim(b0,fr,gr=NULL, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))


## Parmeter estimation縲？essian matrix calculation

b   <- res$par

hhh <- res$hessian



## Calculate the t-statistic

#t値の計算

tval <- b/sqrt(-diag(solve(hhh)))



## L(0), Log-Likelihood when all parameters are 0

#初期尤度

L0 <- fr(b0)

## LL, maximium likelihood

#最終尤度

LL <- res$value



##### Output #####

print(res)

## L(0)

#初期尤度

print(L0)

## LL

#最終尤度

print(LL)

##rho-square

#ρ^2値

print((L0-LL)/L0)

## adjusted rho-square

#修正済ρ^2値

print((L0-(LL-length(b)))/L0)

##estimated parameter values

#パラメータ推定値

print(b)

## t-statistic

#t値

print(tval)

print(x)